import { Meta, Typeset, Story, Canvas } from '@storybook/blocks';
import { width } from './util/decorator';
import { cuiDemo } from './util/demo';
import { demoRatio } from './util/utilities';
import * as UtilitiesRatioStories from './Utilities-ratio.stories';

<Meta of={UtilitiesRatioStories} />

# Aspect ratio

Use the ratio helper to manage the aspect ratios of external content like `<iframe>`s, `<embed>`s, `<video>`s, and `<object>`s. These helpers also can be used on any standard HTML child element (e.g., a `<div>` or `<img>`). Styles are applied from the parent `.cui-ratio` class directly to the child.

Aspect ratios can be customized with modifier classes. By default the following ratio classes are provided:

<Canvas withSource="open">
  <Story of={UtilitiesRatioStories.AspectRatio} />
</Canvas>

Each `.cui-ratio-*` class includes a CSS custom property (or CSS variable) in the selector. You can override this CSS variable to create custom aspect ratios on the fly with some quick math on your part.

For example, to create a 2x1 aspect ratio, set `--cui-aspect-ratio: 50%` on the `.cui-ratio`.
